--- ./cpan/Archive-Tar/bin/ptar.orig	2013-11-04 15:15:37.000000000 +0000
+++ ./cpan/Archive-Tar/bin/ptar	2016-08-04 11:55:54.528911338 +0000
@@ -1,6 +1,7 @@
 #!/usr/bin/perl
 use strict;
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use File::Find;
 use Getopt::Std;
 use Archive::Tar;
--- ./cpan/Archive-Tar/bin/ptardiff.orig	2013-11-04 15:15:37.000000000 +0000
+++ ./cpan/Archive-Tar/bin/ptardiff	2016-08-04 11:55:54.529911338 +0000
@@ -1,5 +1,6 @@
 #!/usr/bin/perl
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use Archive::Tar;
 use Getopt::Std;
--- ./cpan/Archive-Tar/bin/ptargrep.orig	2013-11-04 15:15:37.000000000 +0000
+++ ./cpan/Archive-Tar/bin/ptargrep	2016-08-04 11:55:54.529911338 +0000
@@ -4,6 +4,7 @@
 # archive.  See 'ptargrep --help' for more documentation.
 #
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use warnings;
 
--- ./cpan/CPAN/lib/App/Cpan.pm.orig	2014-01-06 22:46:42.000000000 +0000
+++ ./cpan/CPAN/lib/App/Cpan.pm	2016-08-04 11:55:54.530911338 +0000
@@ -457,9 +457,20 @@ sub AUTOLOAD { 1 }
 sub DESTROY { 1 }
 }
 
+# load a module without searching the default entry for the current
+# directory
+sub _safe_load_module {
+  my $name = shift;
+
+  local @INC = @INC;
+  pop @INC if $INC[-1] eq '.';
+
+  eval "require $name; 1";
+}
+
 sub _init_logger
 	{
-	my $log4perl_loaded = eval "require Log::Log4perl; 1";
+	my $log4perl_loaded = _safe_load_module("Log::Log4perl");
 
     unless( $log4perl_loaded )
         {
@@ -892,7 +903,7 @@ sub _load_local_lib # -I
 	{
 	$logger->debug( "Loading local::lib" );
 
-	my $rc = eval { require local::lib; 1; };
+	my $rc = _safe_load_module("local::lib");
 	unless( $rc ) {
 		$logger->die( "Could not load local::lib" );
 		}
@@ -1006,7 +1017,7 @@ sub _get_file
 	{
 	my $path = shift;
 
-	my $loaded = eval "require LWP::Simple; 1;";
+	my $loaded = _safe_load_module("LWP::Simple");
 	croak "You need LWP::Simple to use features that fetch files from CPAN\n"
 		unless $loaded;
 
@@ -1028,7 +1039,7 @@ sub _gitify
 	{
 	my $args = shift;
 
-	my $loaded = eval "require Archive::Extract; 1;";
+	my $loaded = _safe_load_module("Archive::Extract");
 	croak "You need Archive::Extract to use features that gitify distributions\n"
 		unless $loaded;
 
@@ -1092,7 +1103,7 @@ sub _show_Changes
 sub _get_changes_file
 	{
 	croak "Reading Changes files requires LWP::Simple and URI\n"
-		unless eval "require LWP::Simple; require URI; 1";
+		unless _safe_load_module("LWP::Simple") && _safe_load_module("URI");
 
     my $url = shift;
 
--- ./cpan/CPAN/lib/CPAN.pm.orig	2016-08-04 11:55:44.867911355 +0000
+++ ./cpan/CPAN/lib/CPAN.pm	2016-08-04 11:55:54.532911338 +0000
@@ -1090,6 +1090,8 @@ sub has_usable {
                                ]
               };
     if ($usable->{$mod}) {
+        local @INC = @INC;
+        pop @INC if $INC[-1] eq '.';
         for my $c (0..$#{$usable->{$mod}}) {
             my $code = $usable->{$mod}[$c];
             my $ret = eval { &$code() };
@@ -1118,6 +1120,8 @@ sub has_inst {
       $CPAN::META->{dontload_hash}{$mod}||=1; # unsafe meta access, ok
       return 0;
     }
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     my $file = $mod;
     my $obj;
     $file =~ s|::|/|g;
--- ./cpan/CPAN/scripts/cpan.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/CPAN/scripts/cpan	2016-08-04 11:55:54.532911338 +0000
@@ -1,5 +1,6 @@
 #!/usr/local/bin/perl
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use vars qw($VERSION);
 
--- ./cpan/Digest-SHA/shasum.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/Digest-SHA/shasum	2016-08-04 11:55:54.532911338 +0000
@@ -93,6 +93,7 @@ L<Digest::SHA::PurePerl>.
 
 END_OF_POD
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use Fcntl;
 use Getopt::Long;
--- ./cpan/Digest/Digest.pm.orig	2013-11-04 15:15:37.000000000 +0000
+++ ./cpan/Digest/Digest.pm	2016-08-04 11:55:54.533911338 +0000
@@ -38,7 +38,11 @@ sub new
         unless (exists ${"$class\::"}{"VERSION"}) {
             my $pm_file = $class . ".pm";
             $pm_file =~ s{::}{/}g;
-            eval { require $pm_file };
+            eval {
+                local @INC = @INC;
+                pop @INC if $INC[-1] eq '.';
+                require $pm_file
+	    };
             if ($@) {
                 $err ||= $@;
                 next;
--- ./cpan/Encode/Encode.pm.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/Encode/Encode.pm	2016-08-04 11:55:54.533911338 +0000
@@ -57,6 +57,8 @@ require Encode::Config;
 eval {
     local $SIG{__DIE__};
     local $SIG{__WARN__};
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     require Encode::ConfigLocal;
 };
 
--- ./cpan/Encode/bin/enc2xs.orig	2016-08-04 11:55:44.868911355 +0000
+++ ./cpan/Encode/bin/enc2xs	2016-08-04 11:55:54.534911338 +0000
@@ -4,6 +4,7 @@ BEGIN {
     # with $ENV{PERL_CORE} set
     # In case we need it in future...
     require Config; import Config;
+    pop @INC if $INC[-1] eq '.';
 }
 use strict;
 use warnings;
--- ./cpan/Encode/bin/piconv.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/Encode/bin/piconv	2016-08-04 11:55:54.535911338 +0000
@@ -1,6 +1,7 @@
 #!./perl
 # $Id: piconv,v 2.4 2009/07/08 13:34:15 dankogai Exp $
 #
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use 5.8.0;
 use strict;
 use Encode ;
--- ./cpan/Encode/bin/ucmlint.orig	2013-11-04 15:15:37.000000000 +0000
+++ ./cpan/Encode/bin/ucmlint	2016-08-04 11:55:54.535911338 +0000
@@ -3,6 +3,7 @@
 # $Id: ucmlint,v 2.2 2008/03/12 09:51:11 dankogai Exp $
 #
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 our  $VERSION = do { my @r = (q$Revision: 2.2 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r };
 
--- ./cpan/Encode/bin/unidump.orig	2013-11-04 15:15:37.000000000 +0000
+++ ./cpan/Encode/bin/unidump	2016-08-04 11:55:54.535911338 +0000
@@ -1,5 +1,6 @@
 #!./perl
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use Encode;
 use Getopt::Std;
--- ./cpan/ExtUtils-MakeMaker/bin/instmodsh.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/ExtUtils-MakeMaker/bin/instmodsh	2016-08-04 11:55:54.536911338 +0000
@@ -1,5 +1,6 @@
 #!/usr/bin/perl -w
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use IO::File;
 use ExtUtils::Packlist;
--- ./cpan/File-Fetch/lib/File/Fetch.pm.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/File-Fetch/lib/File/Fetch.pm	2016-08-04 11:55:54.536911338 +0000
@@ -564,6 +564,8 @@ sub _lwp_fetch {
 
     };
 
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     unless( can_load( modules => $use_list ) ) {
         $METHOD_FAIL->{'lwp'} = 1;
         return;
@@ -616,6 +618,8 @@ sub _httptiny_fetch {
 
     };
 
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     unless( can_load(modules => $use_list) ) {
         $METHOD_FAIL->{'httptiny'} = 1;
         return;
@@ -655,6 +659,8 @@ sub _httplite_fetch {
 
     };
 
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     unless( can_load(modules => $use_list) ) {
         $METHOD_FAIL->{'httplite'} = 1;
         return;
@@ -730,6 +736,8 @@ sub _iosock_fetch {
         'IO::Select'       => '0.0',
     };
 
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     unless( can_load(modules => $use_list) ) {
         $METHOD_FAIL->{'iosock'} = 1;
         return;
@@ -811,6 +819,8 @@ sub _netftp_fetch {
     check( $tmpl, \%hash ) or return;
 
     ### required modules ###
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     my $use_list = { 'Net::FTP' => 0 };
 
     unless( can_load( modules => $use_list ) ) {
--- ./cpan/HTTP-Tiny/lib/HTTP/Tiny.pm.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/HTTP-Tiny/lib/HTTP/Tiny.pm	2016-08-04 11:55:54.537911338 +0000
@@ -875,6 +875,8 @@ sub _find_CA_file {
     return $self->{SSL_options}->{SSL_ca_file}
         if $self->{SSL_options}->{SSL_ca_file} and -e $self->{SSL_options}->{SSL_ca_file};
 
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     return Mozilla::CA::SSL_ca_file()
         if eval { require Mozilla::CA };
 
--- ./cpan/IO-Compress/bin/zipdetails.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/IO-Compress/bin/zipdetails	2016-08-04 11:55:54.538911338 +0000
@@ -5,6 +5,7 @@
 # Display info on the contents of a Zip file
 #
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use warnings ;
 
--- ./cpan/IO-Compress/lib/IO/Uncompress/AnyUncompress.pm.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/IO-Compress/lib/IO/Uncompress/AnyUncompress.pm	2016-08-04 11:55:54.538911338 +0000
@@ -27,6 +27,8 @@ Exporter::export_ok_tags('all');
 
 BEGIN
 {
+   local @INC = @INC;
+   pop @INC if $INC[-1] eq '.';
    eval ' use IO::Uncompress::Adapter::Inflate 2.060 ;';
    eval ' use IO::Uncompress::Adapter::Bunzip2 2.060 ;';
    eval ' use IO::Uncompress::Adapter::LZO 2.060 ;';
--- ./cpan/IPC-Cmd/lib/IPC/Cmd.pm.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/IPC-Cmd/lib/IPC/Cmd.pm	2016-08-04 11:55:54.539911338 +0000
@@ -125,6 +125,8 @@ sub can_use_ipc_run     {
     return if IS_WIN98;
 
     ### if we dont have ipc::run, we obviously can't use it.
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     return unless can_load(
                         modules => { 'IPC::Run' => '0.55' },
                         verbose => ($WARN && $verbose),
@@ -152,6 +154,8 @@ sub can_use_ipc_open3   {
 
     ### IPC::Open3 works on every non-VMS platform platform, but it can't
     ### capture buffers on win32 :(
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     return unless can_load(
         modules => { map {$_ => '0.0'} qw|IPC::Open3 IO::Select Symbol| },
         verbose => ($WARN && $verbose),
--- ./cpan/JSON-PP/bin/json_pp.orig	2013-11-04 15:15:37.000000000 +0000
+++ ./cpan/JSON-PP/bin/json_pp	2016-08-04 11:55:54.540911338 +0000
@@ -1,5 +1,6 @@
 #!/usr/bin/perl
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use Getopt::Long;
 
--- ./cpan/Locale-Maketext-Simple/lib/Locale/Maketext/Simple.pm.orig	2013-11-04 15:15:38.000000000 +0000
+++ ./cpan/Locale-Maketext-Simple/lib/Locale/Maketext/Simple.pm	2016-08-04 11:55:54.540911338 +0000
@@ -134,7 +134,12 @@ sub load_loc {
     my $pkg = join('::', grep { defined and length } $args{Class}, $args{Subclass});
     return $Loc{$pkg} if exists $Loc{$pkg};
 
-    eval { require Locale::Maketext::Lexicon; 1 }   or return;
+    eval {
+        local @INC = @INC;
+        pop @INC if $INC[-1] eq '.';
+        require Locale::Maketext::Lexicon;
+        1
+    } or return;
     $Locale::Maketext::Lexicon::VERSION > 0.20	    or return;
     eval { require File::Spec; 1 }		    or return;
 
--- ./cpan/Memoize/Memoize.pm.orig	2013-11-04 15:15:38.000000000 +0000
+++ ./cpan/Memoize/Memoize.pm	2016-08-04 11:55:54.541911338 +0000
@@ -184,7 +184,11 @@ sub _my_tie {
   }
   my $modulefile = $module . '.pm';
   $modulefile =~ s{::}{/}g;
-  eval { require $modulefile };
+  eval {
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
+    require $modulefile
+  };
   if ($@) {
     croak "Memoize: Couldn't load hash tie module `$module': $@; aborting";
   }
--- ./cpan/Pod-Perldoc/lib/Pod/Perldoc.pm.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/Pod-Perldoc/lib/Pod/Perldoc.pm	2016-08-04 11:55:54.542911338 +0000
@@ -558,6 +558,9 @@ sub find_good_formatter_class {
   my @class_list = @{ $self->{'formatter_classes'} || [] };
   $self->die( "WHAT?  Nothing in the formatter class list!?" ) unless @class_list;
 
+  local @INC = @INC;
+  pop @INC if $INC[-1] eq '.';
+
   my $good_class_found;
   foreach my $c (@class_list) {
     DEBUG > 4 and print "Trying to load $c...\n";
@@ -979,6 +982,8 @@ sub new_translator { # $tr = $self->new_
     my $self = shift;
     my $lang = shift;
 
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     my $pack = 'POD2::' . uc($lang);
     eval "require $pack";
     if ( !$@ && $pack->can('new') ) {
--- ./cpan/Sys-Syslog/Syslog.pm.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/Sys-Syslog/Syslog.pm	2016-08-04 11:55:54.542911338 +0000
@@ -884,6 +884,8 @@ sub silent_eval (&) {
 sub can_load {
     my ($module, $verbose) = @_;
     local($SIG{__DIE__}, $SIG{__WARN__}, $@);
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     my $loaded = eval "use $module; 1";
     warn $@ if not $loaded and $verbose;
     return $loaded
--- ./cpan/Test-Harness/bin/prove.orig	2014-01-06 22:46:43.000000000 +0000
+++ ./cpan/Test-Harness/bin/prove	2016-08-04 11:55:54.543911338 +0000
@@ -1,5 +1,6 @@
 #!/usr/bin/perl -w
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use App::Prove;
 
--- ./cpan/Test/lib/Test.pm.orig	2013-11-04 15:15:38.000000000 +0000
+++ ./cpan/Test/lib/Test.pm	2016-08-04 11:55:54.543911338 +0000
@@ -480,7 +480,12 @@ sub _diff_complain {
     my($result, $expected, $detail, $prefix) = @_;
     return _diff_complain_external(@_) if $ENV{PERL_TEST_DIFF};
     return _diff_complain_algdiff(@_)
-     if eval { require Algorithm::Diff; Algorithm::Diff->VERSION(1.15); 1; };
+      if eval {
+          local @INC = @INC;
+          pop @INC if $INC[-1] eq '.';
+          require Algorithm::Diff; Algorithm::Diff->VERSION(1.15);
+          1;
+      };
 
     $told_about_diff++ or print $TESTERR <<"EOT";
 # $prefix   (Install the Algorithm::Diff module to have differences in multiline
--- ./cpan/libnet/Net/Config.pm.orig	2016-08-04 11:55:44.869911355 +0000
+++ ./cpan/libnet/Net/Config.pm	2016-08-04 11:55:54.544911338 +0000
@@ -15,7 +15,12 @@ use strict;
 @ISA     = qw(Net::LocalCfg Exporter);
 $VERSION = "1.11";
 
-eval { local $SIG{__DIE__}; require Net::LocalCfg };
+eval {
+  local @INC = @INC;
+  pop @INC if $INC[-1] eq '.';
+  local $SIG{__DIE__};
+  require Net::LocalCfg;
+};
 
 %NetConfig = (
   nntp_hosts      => [],
--- ./dist/Cwd/Cwd.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/Cwd/Cwd.pm	2016-08-04 11:55:54.544911338 +0000
@@ -208,7 +208,10 @@ if ($^O eq 'os2') {
 my $use_vms_feature;
 BEGIN {
     if ($^O eq 'VMS') {
-        if (eval { local $SIG{__DIE__}; require VMS::Feature; }) {
+        if (eval { local $SIG{__DIE__};
+                   local @INC = @INC;
+                   pop @INC if $INC[-1] eq '.';
+                   require VMS::Feature; }) {
             $use_vms_feature = 1;
         }
     }
--- ./dist/Cwd/lib/File/Spec/Cygwin.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/Cwd/lib/File/Spec/Cygwin.pm	2016-08-04 11:55:54.544911338 +0000
@@ -132,7 +132,11 @@ sub case_tolerant {
   if ($mntopts and ($mntopts =~ /,managed/)) {
     return 0;
   }
-  eval { require Win32API::File; } or return 1;
+  eval { 
+      local @INC = @INC;
+      pop @INC if $INC[-1] eq '.';
+      require Win32API::File; 
+  } or return 1;
   my $osFsType = "\0"x256;
   my $osVolName = "\0"x256;
   my $ouFsFlags = 0;
--- ./dist/Cwd/lib/File/Spec/VMS.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/Cwd/lib/File/Spec/VMS.pm	2016-08-04 11:55:54.545911338 +0000
@@ -39,7 +39,10 @@ via the C<DECC$FILENAME_UNIX_REPORT> CRT
 
 my $use_feature;
 BEGIN {
-    if (eval { local $SIG{__DIE__}; require VMS::Feature; }) {
+    if (eval { local $SIG{__DIE__};
+               local @INC = @INC;
+               pop @INC if $INC[-1] eq '.';
+               require VMS::Feature; }) {
         $use_feature = 1;
     }
 }
--- ./dist/Cwd/lib/File/Spec/Win32.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/Cwd/lib/File/Spec/Win32.pm	2016-08-04 11:55:54.546911338 +0000
@@ -89,7 +89,11 @@ Default: 1
 =cut
 
 sub case_tolerant {
-  eval { require Win32API::File; } or return 1;
+  eval {
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
+    require Win32API::File;
+  } or return 1;
   my $drive = shift || "C:";
   my $osFsType = "\0"x256;
   my $osVolName = "\0"x256;
--- ./dist/ExtUtils-Command/lib/ExtUtils/Command.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/ExtUtils-Command/lib/ExtUtils/Command.pm	2016-08-04 11:55:54.546911338 +0000
@@ -24,7 +24,10 @@ if( $Is_VMS ) {
     my $vms_efs;
     my $vms_case;
 
-    if (eval { local $SIG{__DIE__}; require VMS::Feature; }) {
+    if (eval { local $SIG{__DIE__};
+               local @INC = @INC;
+               pop @INC if $INC[-1] eq '.';
+               require VMS::Feature; }) {
         $vms_unix_rpt = VMS::Feature::current("filename_unix_report");
         $vms_efs = VMS::Feature::current("efs_charset");
         $vms_case = VMS::Feature::current("efs_case_preserve");
--- ./dist/ExtUtils-ParseXS/lib/ExtUtils/xsubpp.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/ExtUtils-ParseXS/lib/ExtUtils/xsubpp	2016-08-04 11:55:54.546911338 +0000
@@ -1,5 +1,6 @@
 #!perl
 use 5.006;
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 eval {
   require ExtUtils::ParseXS;
--- ./dist/I18N-LangTags/lib/I18N/LangTags/Detect.pm.orig	2013-11-04 15:15:38.000000000 +0000
+++ ./dist/I18N-LangTags/lib/I18N/LangTags/Detect.pm	2016-08-04 11:55:54.547911338 +0000
@@ -145,6 +145,8 @@ sub _try_use {   # Basically a wrapper a
   print " About to use $module ...\n" if DEBUG;
   {
     local $SIG{'__DIE__'};
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     eval "require $module"; # used to be "use $module", but no point in that.
   }
   if($@) {
--- ./dist/IO/IO.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/IO/IO.pm	2016-08-04 11:55:54.547911338 +0000
@@ -18,6 +18,8 @@ sub import {
     
     my @l = @_ ? @_ : qw(Handle Seekable File Pipe Socket Dir);
 
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     eval join("", map { "require IO::" . (/(\w+)/)[0] . ";\n" } @l)
 	or croak $@;
 }
--- ./dist/Locale-Maketext/lib/Locale/Maketext.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/Locale-Maketext/lib/Locale/Maketext.pm	2016-08-04 11:55:54.548911338 +0000
@@ -449,6 +449,8 @@ sub _try_use {   # Basically a wrapper a
 
     local $SIG{'__DIE__'};
     local $@;
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
     eval "require $module"; # used to be "use $module", but no point in that.
 
     if($@) {
--- ./dist/Module-CoreList/corelist.orig	2013-11-21 03:21:56.000000000 +0000
+++ ./dist/Module-CoreList/corelist	2016-08-04 11:55:54.548911338 +0000
@@ -130,6 +130,7 @@ requested perl versions.
 
 =cut
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use Module::CoreList;
 use Getopt::Long qw(:config no_ignore_case);
 use Pod::Usage;
--- ./dist/Net-Ping/lib/Net/Ping.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/Net-Ping/lib/Net/Ping.pm	2016-08-04 11:55:54.549911338 +0000
@@ -410,7 +410,11 @@ sub ping_external {
       $timeout            # Seconds after which ping times out
      ) = @_;
 
-  eval { require Net::Ping::External; }
+  eval {
+    local @INC = @INC;
+    pop @INC if $INC[-1] eq '.';
+    require Net::Ping::External;
+  }
     or croak('Protocol "external" not supported on your system: Net::Ping::External not found');
   return Net::Ping::External::ping(ip => $ip, timeout => $timeout);
 }
--- ./dist/Storable/Storable.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/Storable/Storable.pm	2016-08-04 11:55:54.549911338 +0000
@@ -24,7 +24,13 @@ use vars qw($canonical $forgive_me $VERS
 $VERSION = '2.41';
 
 BEGIN {
-    if (eval { local $SIG{__DIE__}; require Log::Agent; 1 }) {
+    if (eval {
+        local $SIG{__DIE__};
+        local @INC = @INC;
+        pop @INC if $INC[-1] eq '.';
+        require Log::Agent;
+        1;
+    }) {
         Log::Agent->import;
     }
     #
--- ./dist/bignum/lib/bigint.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/bignum/lib/bigint.pm	2016-08-04 11:55:54.550911338 +0000
@@ -248,6 +248,8 @@ sub import
     # see if we can find Math::BigInt::Lite
     if (!defined $a && !defined $p)		# rounding won't work to well
       {
+      local @INC = @INC;
+      pop @INC if $INC[-1] eq '.';
       eval 'require Math::BigInt::Lite;';
       if ($@ eq '')
         {
--- ./dist/bignum/lib/bignum.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/bignum/lib/bignum.pm	2016-08-04 11:55:54.550911338 +0000
@@ -155,6 +155,8 @@ sub import
     # see if we can find Math::BigInt::Lite
     if (!defined $a && !defined $p)		# rounding won't work to well
       {
+      local @INC = @INC;
+      pop @INC if $INC[-1] eq '.';
       eval 'require Math::BigInt::Lite;';
       if ($@ eq '')
         {
--- ./dist/bignum/lib/bigrat.pm.orig	2014-01-06 22:46:44.000000000 +0000
+++ ./dist/bignum/lib/bigrat.pm	2016-08-04 11:55:54.551911338 +0000
@@ -148,6 +148,8 @@ sub import
     # see if we can find Math::BigInt::Lite
     if (!defined $a && !defined $p)             # rounding won't work to well
       {
+      local @INC = @INC;
+      pop @INC if $INC[-1] eq '.';
       eval 'require Math::BigInt::Lite;';
       if ($@ eq '')
         {
--- ./ext/Pod-Html/bin/pod2html.orig	2014-01-06 22:46:45.000000000 +0000
+++ ./ext/Pod-Html/bin/pod2html	2016-08-04 11:55:54.551911338 +0000
@@ -118,6 +118,7 @@ This program is distributed under the Ar
 
 =cut
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use Pod::Html;
 
 pod2html @ARGV;
--- ./utils/c2ph.PL.orig	2013-11-04 15:15:39.000000000 +0000
+++ ./utils/c2ph.PL	2016-08-04 11:55:54.552911338 +0000
@@ -280,6 +280,7 @@ Anyway, here it is.  Should run on perl
 
 $RCSID = '$Id: c2ph,v 1.7 95/10/28 10:41:47 tchrist Exp Locker: tchrist $';
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use File::Temp;
 
 ######################################################################
--- ./utils/h2ph.PL.orig	2014-01-06 22:46:46.000000000 +0000
+++ ./utils/h2ph.PL	2016-08-04 11:55:54.552911338 +0000
@@ -36,6 +36,8 @@ $Config{startperl}
 
 print OUT <<'!NO!SUBS!';
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
+
 use strict;
 
 use Config;
--- ./utils/h2xs.PL.orig	2014-01-06 22:46:46.000000000 +0000
+++ ./utils/h2xs.PL	2016-08-04 11:55:54.553911338 +0000
@@ -35,6 +35,8 @@ $Config{startperl}
 
 print OUT <<'!NO!SUBS!';
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
+
 use warnings;
 
 =head1 NAME
--- ./utils/libnetcfg.PL.orig	2013-11-04 15:15:39.000000000 +0000
+++ ./utils/libnetcfg.PL	2016-08-04 11:55:54.554911338 +0000
@@ -97,6 +97,7 @@ Jarkko Hietaniemi, conversion into libne
 
 # $Id: Configure,v 1.8 1997/03/04 09:22:32 gbarr Exp $
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use strict;
 use IO::File;
 use Getopt::Std;
--- ./utils/perlbug.PL.orig	2016-08-04 11:55:44.873911355 +0000
+++ ./utils/perlbug.PL	2016-08-04 11:55:54.554911338 +0000
@@ -84,6 +84,7 @@ my \@patches = (
 
 print OUT <<'!NO!SUBS!';
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
 use warnings;
 use strict;
 use Config;
--- ./utils/perldoc.PL.orig	2013-11-04 15:15:39.000000000 +0000
+++ ./utils/perldoc.PL	2016-08-04 11:55:54.555911338 +0000
@@ -44,7 +44,10 @@ $Config{startperl}
 # This "$file" file was generated by "$0"
 
 require 5;
-BEGIN { \$^W = 1 if \$ENV{'PERLDOCDEBUG'} }
+BEGIN {
+    \$^W = 1 if \$ENV{'PERLDOCDEBUG'};
+    pop \@INC if \$INC[-1] eq '.';
+}
 use Pod::Perldoc;
 exit( Pod::Perldoc->run() );
 
--- ./utils/perlivp.PL.orig	2013-11-04 15:15:39.000000000 +0000
+++ ./utils/perlivp.PL	2016-08-04 11:55:54.555911338 +0000
@@ -39,6 +39,8 @@ print OUT "\n# perlivp $^V\n";
 
 print OUT <<'!NO!SUBS!';
 
+BEGIN { pop @INC if $INC[-1] eq '.' }
+
 sub usage {
     warn "@_\n" if @_;
     print << "    EOUSAGE";
--- ./utils/splain.PL.orig	2013-11-04 15:15:39.000000000 +0000
+++ ./utils/splain.PL	2016-08-04 11:55:54.555911338 +0000
@@ -38,6 +38,12 @@ $Config{startperl}
 	if \$running_under_some_shell;
 !GROK!THIS!
 
+print OUT <<'!NO!SUBS!';
+
+BEGIN { pop @INC if $INC[-1] eq '.' }
+
+!NO!SUBS!
+
 while (<IN>) {
     print OUT unless /^package diagnostics/;
 }